#ifndef SCENE_H
#define SCENE_H

#include <QObject>
#include <QtOpenGL>
#include <QGLFunctions>
#include <QOpenGLFunctions>

#include <scenenode.h>
#include <sceneobject.h>
#include <sceneprimitive.h>

class Scene: public QObject
{
    Q_OBJECT
public:
    Scene();
    void draw();

    int simpleScene();


    void moveActive(QVector3D dir);
    void rotateActive(QQuaternion rot);

    SceneObject *getActive();
    SceneObject *setActive(int id);


signals:
    void activChanged();

private:
    SceneNode *root;
    SceneObject *active;

    SceneNode *getRoot();


};

#endif // SCENE_H
