#include "sceneobject.h"

SceneObject::SceneObject(QObject *parent)
    :QObject(parent)
{
    id = 3;
    name = QString("Scene Object "+id);
    rotation = QQuaternion();
    translation = QVector3D();
}


int SceneObject::getID(){return id;}

QString SceneObject::getName(){return name;}


void SceneObject::move(QVector3D dir)
{
    translation+=dir;
}
void SceneObject::rotate(QQuaternion rot)
{
    rotation *= QQuaternion(rotation*rot);
}

void SceneObject::draw(){qDebug()<<"Drawing abstract Scene Element";}

SceneObject *SceneObject::find(int id)
{
   if(this->id == id){
       return this;
   } else{
       return NULL;
   }

}


 void SceneObject::applyTransformation()
 {
     QMatrix4x4 mat = QMatrix4x4();
     mat.translate(translation);
     glMultMatrixf(mat.data());

     mat = QMatrix4x4();
     mat.rotate(rotation);
     glMultMatrixf(mat.data());
 }
