#ifndef SCENEPRIMITIVE_H
#define SCENEPRIMITIVE_H

#include <sceneobject.h>

enum PrimitiveType{Quader=0,Sphere,Cylinder,Torus};

class ScenePrimitive : public SceneObject
{
   Q_OBJECT
private:
    static int quaderCount;
    static int sphereCount;
    static int cylinderCount ;
    static int torusCount;

    PrimitiveType type;
    int tesselation;
    GLUquadric *qobj;
    float *color;

    void drawCube(int tesselation);

public:


    void draw();

    void setMaterial(float *color);
    ScenePrimitive(PrimitiveType type, int tesselation, QObject *parent);
};

#endif // SCENEPRIMITIVE_H
